package startParam;
import javax.swing.*;

import java.awt.event.*;
import java.text.NumberFormat;
import java.util.*;
import java.io.*;

public class StartParam{

public static void main( String[] args) throws Exception{
	NumberFormat nf = NumberFormat.getInstance();
	String[] lineData;
	
	int totalread=0;
	int itemCnt=0;

	String tempFileName =  System.getProperty("org.jarshell.start.filenames");

	if (tempFileName!=null && !tempFileName.equals("")){
		InputStream is = null;
		ArrayList l = new ArrayList();

		if(tempFileName.equals("-")) is = System.in;
		else is = new FileInputStream(tempFileName);

		DataInputStream dis = new DataInputStream( new BufferedInputStream(is));
		int len = dis.readInt();
		totalread+=4;
		while(len!=0){ // end marker
			if (len>10000) {// sanity check
				throw new IllegalStateException("In file:>" + tempFileName +"< there is an error at pos:"+totalread);
				}
			byte[] data = new byte[len];
			dis.read( data); // todo: read until full
			totalread+=len;
			l.add( new String(data, "utf-8"));
			len = dis.readInt();
			totalread+=4;
			}
		dis.close();

		if (tempFileName!=null && !tempFileName.equals("-"))
			new File(tempFileName).delete();

		itemCnt = l.size();
		lineData =(String[])l.toArray(new String[0]); 
		
		}
	else{
		lineData =args;
		}

	JFrame frame = new JFrame("Start Parameter");
	JTabbedPane tab = new JTabbedPane();

	tab.add("Parameter", new JScrollPane(new JList( lineData  )));
	
	ArrayList prop = new ArrayList(System.getProperties().keySet());
	Collections.sort(prop);
	ArrayList pairs = new ArrayList(prop.size());
	for (Iterator i = prop.iterator(); i.hasNext();) {
		String key = (String) i.next();
		pairs.add(key + "=" + System.getProperty(key));
	}
	tab.add("System Properties", new JScrollPane(new JList( pairs.toArray() )));	
	
	frame.getContentPane().add(tab);


	frame.addWindowListener(new WindowAdapter() {public void windowClosing(WindowEvent e) {System.exit(0);}});
	frame.pack();
	frame.setVisible(true);
	frame.setTitle("Start Parameter - File: \"" +tempFileName +
					"\", readBytes:" + nf.format(totalread)  + 
					", items:" + nf.format(itemCnt));
	}

}
